<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\FuncoesService;

class FuncoesController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $FuncoesService;
   
    public function __construct($crudService, $environment, FuncoesService $FuncoesService) {
        parent::__construct($crudService, $environment);
        $this->FuncoesService = $FuncoesService;
    }

    public function getPositionsController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();

        $var = $this->FuncoesService->getPositionsService($params);
        $dtsVal = new DataSet('info', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function positionsListController(DTO\Request $request, DTO\Response $response) {
        $var = $this->FuncoesService->positionsListService();
        $dtsVal = new DataSet('info', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function createPositionController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();

        $nmperfilacesso = $params['params']['NMPERFILACESSO'];
        $idpermisssusuario = $params['params']['IDPERMISSSUSUARIO'];
        $idpermisssfuncoes = $params['params']['IDPERMISSSFUNCOES'];
        $idpermissstarefas = $params['params']['IDPERMISSSTAREFAS'];
        $idpermissslocais = $params['params']['IDPERMISSSLOCAIS'];
        $idpermissschecklist = $params['params']['IDPERMISSSCHECKLIST'];
        $idpermisssrelatorios = $params['params']['IDPERMISSSRELATORIOS'];
        $idpermisssgraficos = $params['params']['IDPERMISSSGRAFICOS'];
        
        $var = $this->FuncoesService->createPositionService($nmperfilacesso, $idpermisssusuario, $idpermisssfuncoes, $idpermissstarefas, $idpermissslocais, $idpermissschecklist, $idpermisssrelatorios, $idpermisssgraficos);
        $dtsVal = new DataSet('info', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function getPositionInfoController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        
        $var = $this->FuncoesService->getPositionInfoService($params["id"]);
        $dtsVal = new DataSet("info", $var);
        $response->addDataSet($dtsVal);
    }
    
    public function updatePositionController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        
        $nrperfilacesso = $params['params']['NRPERFILACESSO'];
        $nmperfilacesso = $params['params']['NMPERFILACESSO'];
        $idpermisssusuario = $params['params']['IDPERMISSSUSUARIO'];
        $idpermisssfuncoes = $params['params']['IDPERMISSSFUNCOES'];
        $idpermissstarefas = $params['params']['IDPERMISSSTAREFAS'];
        $idpermissslocais = $params['params']['IDPERMISSSLOCAIS'];
        $idpermissschecklist = $params['params']['IDPERMISSSCHECKLIST'];
        $idpermisssrelatorios = $params['params']['IDPERMISSSRELATORIOS'];
        $idpermisssgraficos = $params['params']['IDPERMISSSGRAFICOS'];
        
        $var = $this->FuncoesService->updatePositionService($nrperfilacesso, $nmperfilacesso, $idpermisssusuario, $idpermisssfuncoes, $idpermissstarefas, $idpermissslocais, $idpermissschecklist, $idpermisssrelatorios, $idpermisssgraficos);
        $dtsVal = new DataSet('info', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function deletePositionsController(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();

        $var = $this->FuncoesService->deletePositionsService($params);
        $dtsVal = new DataSet('info', array("resultado" => $var));
        $response->addDataSet($dtsVal);
    }

}
?>