<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class CardsFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }

    public function buscaTipoLocal() {
        $sql = "SELECT NMTIPOLOCALCLI, NRTIPOLOCALCLI
                  FROM FCM_TIPOLOCALCLI";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function buscaLocal() {
        $sql = "SELECT NRLOCALCLIENTE,NMLOCALCLIENTE
                  FROM FCM_LOCALCLI";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function buscaChecklist() {
        $sql = "SELECT NRCHECKLIST, NMCHECKLIST
                  FROM FCM_CHECKLIST";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function buscaItensChecklist($param) {
        $sql = "SELECT A.NRATIVIDADE, A.NMATIVIDADE FROM FCM_ATIVIDADE A
                JOIN FCM_ATIVIDADECHK B
                ON A.NRATIVIDADE = B.NRATIVIDADE
                AND A.NRORG = B.NRORG
                JOIN FCM_CHECKLIST C
                ON B.NRCHECKLIST = C.NRCHECKLIST
                AND B.NRORG = C.NRORG
                WHERE C.NRCHECKLIST = ".$param['NRCHECKLIST'];
                
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function buscaFuncionario() {
        $sql = "SELECT NMFUNCIONARIO, NRFUNCIONARIO
                  FROM FCM_FUNCIONARIO";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function buscaCriterioTarefa($params) {
        $sql = "SELECT NRTAREFACHK, NMTAREFACHK
                  FROM FCM_TAREFACHK
                  WHERE NRCHECKLIST IN (".$params['NRCHECKLIST'].")";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function buscaTarefa($params) {
        $sql = "SELECT A.NRTAREFA, A.NMTAREFA, B.NMATIVIDADE FROM FCM_TAREFA A
                JOIN FCM_ATIVIDADE B
                ON A.NRATIVIDADE = B.NRATIVIDADE
                AND A.NRORG = B.NRORG
                WHERE B.NRATIVIDADE IN (".$params['NRATIVIDADE'].")";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function buscaCriterioAtividade($params){
        $sql = "SELECT A.NRCRITERIOTAREFACHK, A.NRCRITERIOTAREFA,B.DSCRITERIOTAREFA, A.NRTAREFACHK FROM FCM_CRITERIOTAREFACHK A
                JOIN FCM_CRITERIOTAREFA B
                ON A.NRCRITERIOTAREFA = B.NRCRITERIOTAREFA
                AND A.NRORG = B.NRORG
                JOIN FCM_TAREFACHK C
                ON A.NRTAREFACHK = C.NRTAREFACHK
                AND A.NRORG = C.NRORG
                JOIN FCM_ATIVIDADECHK D
                ON C.NRATIVIDADECHK = D.NRATIVIDADECHK
                AND C.NRORG = D.NRORG
                JOIN FCM_CHECKLIST E
                ON E.NRCHECKLIST = D.NRCHECKLIST
                AND E.NRORG = D.NRORG
                WHERE E.NRCHECKLIST = ".$params['NRCHECKLIST']."
                AND D.NRATIVIDADECHK IN (".$params['NRATIVIDADECHK'].")
                AND C.NRTAREFACHK IN (".$params['NRTAREFACHK'].")";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function buscaCard($params){
        $sql = "SELECT A.NRCHECKLISTAGEND, A.NMCHECKLISTAGEND, A.NRLOCALCLIENTE, C.NMLOCALCLIENTE, D.NMLOCALCLIENTE as NMLOCALCLIENTE2, D.NRLOCALCLIENTEPAI, C.NMLOCALCLIENTE || ' | ' || D.NMLOCALCLIENTE AS NMLOCAL,
        A.NRCHECKLIST, B.NMCHECKLIST, A.NRFUNCIONARIO, E.NMFUNCIONARIO, A.IDSITUACAOAGEND ,CASE A.IDSITUACAOAGEND 
            WHEN '1' THEN 'Pendente'
            WHEN '2' THEN 'Em Andamento'
            WHEN '3' THEN 'Concluido'
            WHEN '4' THEN 'Cancelado'
            ELSE NULL END AS NMIDSITUACAOAGEND, A.DTHORAAGEND
        FROM FCM_CHECKLISTAGEND A
        JOIN FCM_CHECKLIST B
        ON A.NRCHECKLIST = B.NRCHECKLIST
        AND A.NRORG = B.NRORG
        JOIN FCM_LOCALCLI C
        ON A.NRLOCALCLIENTE = C.NRLOCALCLIENTE
        AND A.NRORG = C.NRORG
        JOIN FCM_LOCALCLI D
        ON D.NRLOCALCLIENTE = C.NRLOCALCLIENTEPAI
        AND D.NRORG = C.NRORG
        JOIN FCM_FUNCIONARIO E
        ON E.NRFUNCIONARIO = A.NRFUNCIONARIO
        AND A.NRORG = E.NRORG ".$params['FILTRO'];
        
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function insertNovaTarefa($param){
        $sql="INSERT INTO FCM_CHECKLISTAGEND (NRCHECKLISTAGEND, NMCHECKLISTAGEND, NRLOCALCLIENTE, NRCHECKLIST, NRFUNCIONARIO, 
                                              IDSITUACAOAGEND, DTHORAAGEND,  IDATIVO, NRORG, DTINCLUSAO, 
                                              CDOPERINCLUSAO, NRORGINCLUSAO)
              VALUES (:NRCHECKLISTAGEND, :NMCHECKLISTAGEND, :NRLOCALCLIENTE, :NRCHECKLIST, :NRFUNCIONARIO, 
                      :IDSITUACAOAGEND,TO_DATE(:DTHORAAGEND,'YYYY/MM/DD HH24:MI'),  'S', :NRORG, SYSDATE, 
                      :OPERADOR, :NRORG)";
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    public function insertNovaTarefa2($param){
        $sql="INSERT INTO FCM_TAREFAAGEND (NRTAREFAAGEND, NRCHECKLISTAGEND, NRTAREFACHK, NRFUNCIONARIO, DTHORATAREFAAGEND, 
                                           DSOBSTAREFAAGEND, IDREALIZADO,  IDATIVO, NRORG, DTINCLUSAO, 
                                           CDOPERINCLUSAO, NRORGINCLUSAO)
              VALUES (:NRTAREFAAGEND, :NRCHECKLISTAGEND, :NRTAREFACHK, :NRFUNCIONARIO, TO_DATE(:DTHORAAGEND,'YYYY/MM/DD HH24:MI'), 
                      :DSOBSTAREFAAGEND, 'N',  'S', :NRORG, SYSDATE, 
                      :OPERADOR, :NRORG)";
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    public function insertNovaTarefa3($param){
        $sql="INSERT INTO FCM_CRITERIOTARAGEND (NRCRITERIOTARAGEND, NMCRITERIOTARAGEND, NRTAREFAAGEND, NRCRITERIOTAREFACHK, IDATIVO, NRORG,
                                                DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
                                        VALUES (:NRCRITERIOTARAGEND,:NMCRITERIOTARAGEND, :NRTAREFAAGEND, :NRCRITERIOTAREFACHK, 'S', :NRORG,
                                                SYSDATE, :OPERADOR, :NRORG)";
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
        
    public function insertNovaTarefa4($param){
        $sql="INSERT INTO FCM_GERENCIAMENTOCHK (NRGERENCIAMENTOCHK, NMGERENCIAMENTOCHK, NRLOCALCLIENTE, NRCHECKLIST, NRFUNCIONARIO, 
                             IDSITUACAOGERCHK, DTHORAAGEND, IDATIVO, NRORG, DTINCLUSAO, 
                             CDOPERINCLUSAO, NRORGINCLUSAO)
       VALUES (:NRGERENCIAMENTOCHK, :NMGERENCIAMENTOCHK, :NRLOCALCLIENTE, :NRCHECKLIST, :NRFUNCIONARIO, 
                             '1',  :DTHORAAGEND, 'S', :NRORG, SYSDATE, 
                             :OPERADOR, :NRORG)";
                             
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    public function insertNovaTarefa5($param){
        $sql="INSERT INTO FCM_TAREFAGERCHK (NRTAREFAGERCHK, NRGERENCIAMENTOCHK, NRTAREFACHK, NRFUNCIONARIO, DTHORATAREFAGERCHK, 
                             DSOBSTAREFAGERCHK, IDATIVO, NRORG, DTINCLUSAO,  CDOPERINCLUSAO, 
                             NRORGINCLUSAO)
       VALUES (:NRTAREFAGERCHK, :NRGERENCIAMENTOCHK, :NRTAREFACHK, :NRFUNCIONARIO, :DTHORATAREFAGERCHK, 
                             :DSOBSTAREFAGERCHK, 'S', :NRORG, SYSDATE, :OPERADOR, 
                             :NRORG)";
                             
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    public function insertNovaTarefa6($param){
        $sql="INSERT INTO FCM_CRITERIOTARGERCHK (NRCRITERIOTARGERCHK, NMCRITERIOTARGERCHK, NRTAREFAGERCHK, NRCRITERIOTAREFACHK, IDATIVO, 
                                   NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
       VALUES (:NRCRITERIOTARGERCHK, :NMCRITERIOTARGERCHK,:NRTAREFAGERCHK, :NRCRITERIOTAREFACHK,  'S', 
                  :NRORG, SYSDATE, :OPERADOR, :NRORG)";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
}
?>