/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: TRG_DTULTATU_HIPD                                                    */
/*                                                                            */
/* Descrio:                                                                 */
/* Atualiza a data da ultima atualizao da tabela HISTORICO PADRAO           */
/*                                                                            */
/* Criao:                                                                   */
/* 07/01/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/


IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_HIPD'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_HIPD
GO

CREATE TRIGGER DTULTATU_HIPD ON HISTPADR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'HISTPADR', 'CDHISTPADR=' + CDHISTPADR+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE HISTPADR
      SET DTULTATUHIPD = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(HISTPADR.CDHISTPADR,0) = ISNULL(INSERTED.CDHISTPADR,0))
   END;
END;

GO
