import { Button, Image } from '@zeedhi/common';
import { Http, IDictionary } from '@zeedhi/core';

export class QRCodeController {
  public collapseQrCode({ component }: {component: Button}) {
    // const collapse = (component.parent.parent as any).getChildInstance('col4').getChildInstance('expandedCollapse');
    const rowParent: any = component!.parent!.parent;
    const collapse = rowParent!.getChildInstance('col2')!.getChildInstance('expandedCollapse');
    collapse.isVisible = !collapse.isVisible;
  }

  public generateQRCode({ component } : {component: Image}) {
    const urlSrc: string = component.src;
    Http.post('/getQRCode', { url: urlSrc })
      .then((response: IDictionary) => {
        let uri: string = '';
        ([uri] = response.data.dataset.QRCodeUri);
        component.src = uri;
      })
      .catch((err) => {
        throw err;
      });
  }
}
